

LIST_OF_NPC_FOR_DAMAGEREPORT<-[];
ADD_TO_MAILING_LIST <- 1;
REMOVE_FROM_MAILING_LIST <- 0;
const HEADSHOT_VAL = 0.627299 //z difference from pos
const HEADSHOT_VAL_AIMING = 0.17 //while aiming

/*ManageDamageReport, work can be DAMAGEREPORT.ASSIGN or DAMAGEREPORT.UNASSIGN
This function tells 'player' to inform server damage reports that happen to 'npcid' when
    the same player shoots them.
//To undo, call this function with parameter work: DAMAGEREPORT.UNASSIGN.
//work can be DAMAGEREPORT.ASSIGN, DAMAGEREPORT.UNASSIGN. -->Stream values
//Returns null */
function ManageDamageReport( player, npcid, work ) 
{
	local npc = FindPlayer( npcid );
	if( npc )
	{
		Stream.StartWrite();
		Stream.WriteInt( work ); 
		Stream.WriteByte( npcid ); // needed value
		Stream.SendStream( player );
	}	
}
/*This function keeps a record of npc id's in server side ( in one dimensional array )
When an npc quits, this must be called with: REMOVE_FROM_MAILING_LIST  
If all client are to report to the server, the attacks made to npc by them 
( shooting ruger, M4, etc), call this function with (npcid, ADD_TO_MAILING_LIST)
//ManageMailingList, operation can be ADD_TO_MAILING_LIST or REMOVE_FROM_MAILING_LIST
*/
function ManageMailingList( npcid, operation )
{
	local array = LIST_OF_NPC_FOR_DAMAGEREPORT; //reference
	
	local isInMailingList = array.find( npcid ) == null ? false: true;

	local assignment;

	if( operation == ADD_TO_MAILING_LIST )
	{ 
		if( isInMailingList )
			return ;
		array.push( npcid ) ;
		assignment = DAMAGEREPORT.ASSIGN ; 
	}
    else if( operation == REMOVE_FROM_MAILING_LIST )
	{
		if( !isInMailingList )
			return ;
		array.remove( array.find( npcid ) ) ;
		assignment = DAMAGEREPORT.UNASSIGN ;
	}
	else return;
	for( local i = 0 ; i < GetMaxPlayers() ; i++ )
	{
		local player = FindPlayer( i );
		if( player && !IsPlayerNPC( i ) )
			ManageDamageReport( player, npcid, assignment );
	}
}
function SendDamageReportToNPC( playerid, npcid, data, damage, hexval )
{
	local bodypart = data & 7 ;
	local weapon = data >> 3 ;
	
	if( damage == 0 )
	{
		//Client decided server to decide damage value.
		damage = GetWeaponDataValue( weapon, 6 ) / 3;
		damage = damage.tointeger();
	}	
	local message = playerid + " " + weapon + " "+ damage + " " + 
	bodypart ;
	local npc = FindPlayer( npcid );
	if( npc )
	{
		ClientMessage( message, npc, hexval >> 16, ( hexval & 0xFF00 ) >>8, hexval & 0xFF );
	}
}
//Ref:https://forum.vc-mp.org/?topic=8836 for reference onClientScriptData
function onClientScriptData( player )
{
    local id = Stream.ReadInt();
    switch( id ) {
        case DAMAGEREPORT.NPC_IS_HIT: {
            local npcid = Stream.ReadByte();
			local data = Stream.ReadByte();
			local damage = Stream.ReadByte();
			local rgbkey = SERVER.SHOT_BY_WEAPON;
			SendDamageReportToNPC( player.ID, npcid, data, damage, rgbkey );
        } break;
		
		case DAMAGEREPORT.COLLISSION_REPORT:{
			//print("collission report arrived");
			local entity_type = Stream.ReadByte();
			local entity_id = Stream.ReadByte();
			local entity_pos = Vector( Stream.ReadFloat(), Stream.ReadFloat(), Stream.ReadFloat() );
			local hitposition = Vector( Stream.ReadFloat(), Stream.ReadFloat(), Stream.ReadFloat() );
			local weapon = Stream.ReadByte(); 
			local shooter = Stream.ReadByte();
			/*local msg =format("entity type: %d, id: %d, pos:(%f,%f,%f), hitpos: (%f,%f,%f), weapon:%d", entity_type,
			entity_id, entity_pos.x, entity_pos.y, entity_pos.z, hitposition.x, hitposition.y, hitposition.z, weapon );
			print(msg);*/
			/* OBJ_PLAYER 0, OBJ_VEHICLE 1, OBJ_BUILDING 2*/
			if( entity_type == 0 ) //OBJ_PLAYER
			{
				if( IsPlayerNPC( entity_id ) && FindPlayer( entity_id) )
				{
					local damage=0, bodypart = 0; //0 means body
					
					if( ( hitposition.z - entity_pos.z ) > HEADSHOT_VAL  ||
					( shooter==player.ID && ( hitposition.z - entity_pos.z ) > HEADSHOT_VAL_AIMING  
					&& ( (FindPlayer( entity_id).GameKeys && 1) || (FindPlayer( entity_id ).IsCrouching) ) ) )
					{
						//HeadShot
						if( weapon == 26 || weapon == 27 || weapon == 28 || weapon == 29
							|| weapon == 32 || weapon == 33 )
						{
							damage = 255 ; //Put 255 to kill npc
						}
						bodypart = 6 ; //6 means head
					}
					local data =  ( weapon << 3 ) | bodypart ;
					SendDamageReportToNPC( player.ID, entity_id, data, damage, SERVER.SHOT_BY_WEAPON );
					//print("Done");
				}//else print("Not npc: "+ entity_id);
			}
		}
		break;
		case DAMAGEREPORT.CALL_PLOS_USING_AIMPOS:
		{
			local npcid = Stream.ReadByte();
			local x = Stream.ReadFloat();
			local y = Stream.ReadFloat();
			local z = Stream.ReadFloat();
			local weapon = Stream.ReadByte();
			local start = player.AimPos;
			local p = player.AimDir.x;
			local q = player.AimDir.y;
			local r = player.AimDir.z;
			local angle= player.Angle;
			//Find alpha which i call the upward angle or downward angle
			local alpha;
			if( p < 0.001 && p > -0.001 ) //p = 0 
			{
				alpha = PI + q ;
			}else 
				alpha = q ;
			//Now,
			local dx, dy, dz;
			dz = sin( alpha );
					
			dx = cos( alpha ) * sin( -angle );
			dy = cos( alpha ) * cos( angle );
			
			start+=Vector( dx, dy, dz );
			ProcessLineOfSight( player, start, Vector(x,y,z), 2, weapon, npcid );
		}
	}
}
//ProcessLineOfSight(FindPlayer(1),Vector(-1066.433228, 81.319473, 11.420822),Vector( 90*-0.340332,90* -0.939496, 90*0.039003 )+Vector(-1066.433228, 81.319473, 11.420822), 15, 29)
function ProcessLineOfSight( player, start, end, flags, weapon, npcid ) //identifier any value. onthe report same value back
{
	if(!player)throw("Error, player is null");
	Stream.StartWrite();
	Stream.WriteInt(DAMAGEREPORT.PROCESS_LINE_OF_SIGHT);
	Stream.WriteFloat(start.x);
	Stream.WriteFloat(start.y);
	Stream.WriteFloat(start.z);
	Stream.WriteFloat(end.x);
	Stream.WriteFloat(end.y);
	Stream.WriteFloat(end.z);
	Stream.WriteByte(flags);
	Stream.WriteByte(weapon);
	Stream.WriteByte(npcid);
	Stream.SendStream( player );
	//print("Collission report requested");
}