enum DAMAGEREPORT		//This are stream values 
{
	ASSIGN= -0x01, //we will use negative values
	UNASSIGN= -0x02,
	NPC_IS_HIT= -0x03,
	PROCESS_LINE_OF_SIGHT = -0x04,
	SHOW_FLAG_VALUES = -0x05,
	COLLISSION_REPORT = -0x06,
	CALL_PLOS_USING_AIMPOS = -0x07,
	NPC_IS_HIT2= -0x08
}
LIST_OF_NPC_FOR_DAMAGEREPORT<-[];
const ADD_TO_MAILING_LIST = 1;
const REMOVE_FROM_MAILING_LIST = 0;

enum BODYPART{
	BODY = 0,
	TORSO = 1,
	LEFTARM = 2,
	RIGHTARM = 3,
	LEFTLEG = 4,
	RIGHTLEG = 5,
	HEAD = 6
}

function ManageMailingList( npcid, operation )
{
    local array = LIST_OF_NPC_FOR_DAMAGEREPORT; //reference

	local isInMailingList = array.find( npcid ) == null ? false: true;

	if( operation == ADD_TO_MAILING_LIST )
	{ 
		if( isInMailingList )
			return ;
		array.push( npcid ) ;
	}
    else if( operation == REMOVE_FROM_MAILING_LIST )
	{
		if( !isInMailingList )
			return ;
		array.remove( array.find( npcid ) ) ;
	}
	else return;
}
function Server::ServerData( stream )
{
    local id = stream.ReadInt();
    switch( id ) {
        case DAMAGEREPORT.ASSIGN:
        case DAMAGEREPORT.UNASSIGN:
        {
            local npcid = stream.ReadByte() ;
            local operation = ( id == DAMAGEREPORT.ASSIGN ) ? ADD_TO_MAILING_LIST:
                                     REMOVE_FROM_MAILING_LIST ;
            ManageMailingList( npcid, operation );
        } break;
		case DAMAGEREPORT.PROCESS_LINE_OF_SIGHT:
		{
			//Console.Print("Processing Line of sight");
			local start=Vector( stream.ReadFloat(), stream.ReadFloat(), stream.ReadFloat() );
			local end = Vector( stream.ReadFloat(), stream.ReadFloat(), stream.ReadFloat() );
			local flags = stream.ReadByte();
			local weapon = stream.ReadByte(); //some byte. can be weapon id 
			local shooter = stream.ReadByte(); //id of shooter
			local rt = RayTrace( start, end, flags );
			if(rt.Collided)
			{
				if(rt.Entity!=null)
				{
					local hitPosition = rt.Position;
					if(rt.Entity.Type == OBJ_PLAYER )
					{
						
						//Console.Print("Hit at "+ hitPosition.X+","+hitPosition.Y+", "+hitPosition.Z);
						local Data = Stream() ;
						Data.WriteInt( DAMAGEREPORT.COLLISSION_REPORT ) ; // key 
						//Console.Print("OK");
						Data.WriteByte( OBJ_PLAYER ) ;
						Data.WriteByte( rt.Entity.ID ) ;
						Data.WriteFloat( rt.Entity.Position.X );
						Data.WriteFloat( rt.Entity.Position.Y );
						Data.WriteFloat( rt.Entity.Position.Z );
						Data.WriteFloat( hitPosition.X );
						Data.WriteFloat( hitPosition.Y );
						Data.WriteFloat( hitPosition.Z );
						Data.WriteByte( weapon );
						Data.WriteByte( shooter );
						Server.SendData( Data );
						//Console.Print("Data Send");
						
					}
				}//else Console.Print("Entity is null");
				/*if(rt.Entity.Type == OBJ_PLAYER )Console.Print(" Player was hit");
				else if(rt.Entity.Type == OBJ_VEHICLE)Console.Print("VEhicle was hit");
				else if(rt.Entity.Type == OBJ_BUILDING )Console.Print("Building was hit");
				else if( rt.Entity== null )Console.Print("Nothing was hit");*/
			}//else Console.Print("Not collided");
		}
		break;
		case DAMAGEREPORT.SHOW_FLAG_VALUES:
		{
			/*Console.Print("RAY_BUILDING "+ RAY_BUILDING);
			Console.Print("RAY_PED "+RAY_PED );
			Console.Print("RAY_VEHICLE "+RAY_VEHICLE);
			Console.Print("RAY_OBJECT"+RAY_OBJECT);*/
			Console.Print("OBJ_PLAYER "+OBJ_PLAYER);
			Console.Print("OBJ_VEHICLE "+OBJ_VEHICLE);
			Console.Print("OBJ_BUILDING "+OBJ_BUILDING);
			
		}
		break;
        default: {
            // even was called, but with an ID not existing in this switch
        } break;
    }
}

function SendDamageReportToServer( npcid, data, damage )
{
    local Data = Stream() ;
    Data.WriteInt( DAMAGEREPORT.NPC_IS_HIT ) ; // key 
    Data.WriteByte( npcid ) ;
    Data.WriteByte( data ) ;
    Data.WriteByte( damage );
    Server.SendData( Data );
}
function Player::PlayerShoot(player, weapon, hitEntity, hitPosition){
	if(! player.Local )return;
    if( hitEntity.Type == OBJ_PLAYER )
    {
        //Console.Print("OBJ_PLAYER");
		local pid = hitEntity.ID ; 
        local array = LIST_OF_NPC_FOR_DAMAGEREPORT;
        if( array.find( pid )!= null )
        {//Console.Print("array.find true ");
            local npcid = pid ;
            local damage = 0;
            local bodypart;
            //Calculate damage
            local hit = hitPosition ;
            local playerpos = Vector( player.Position );
            local pos = hitEntity.Position ;
            local diff = sqrt( 
                pow( hit.X - pos.X, 2) + pow( hit.Y - pos.Y , 2) + pow( hit.Z - pos.Z , 2 )
            );
            bodypart = BODYPART.BODY ;
            if( diff < 0.9  )  //This is needed due to bug in client side function PlayerShoot
            {
               
				local Data = Stream() ;
				Data.WriteInt( DAMAGEREPORT.COLLISSION_REPORT ) ; // key 
				//Console.Print("less than 0.9");
				Data.WriteByte( OBJ_PLAYER ) ;
				Data.WriteByte( npcid ) ;
				Data.WriteFloat( pos.X );
				Data.WriteFloat( pos.Y );
				Data.WriteFloat( pos.Z );
				Data.WriteFloat( hitPosition.X );
				Data.WriteFloat( hitPosition.Y );
				Data.WriteFloat( hitPosition.Z );
				Data.WriteByte( weapon );
				Server.SendData( Data );
				//Console.Print("Done");
			
            }else
			{
				//Tell server to call PLOS with AimPos values
				local Data = Stream() ;
				Data.WriteInt( DAMAGEREPORT.CALL_PLOS_USING_AIMPOS ) ; // key 
						//Console.Print("OK");
				Data.WriteByte( npcid ) ;
				Data.WriteFloat( hit.X );
				Data.WriteFloat( hit.Y );
				Data.WriteFloat( hit.Z );
				Data.WriteByte( weapon );
				Server.SendData( Data );
			}
        }//else of array( pid ) != null
    }//else of hitEntity.Type == OBJ_PLAYER
}